#This Plesk mk-file. Need for using portupgrade for update and install standart packages 
#from ports. Packages may be installed from various repositories (defined in portupgrade's
# config file.
#Target may be redefined in Makefile of port. Definiton some targets must to be before 
#include this file.
#
#Suported OPTIONS
#
#NO_CONFIGURE = yes               Skip configure target
#
#NO_BUILD = yes                   Block with build targets was skipped.
#
#NO_INSTALL = yes                 Block with install targets was skipped
#
#NO_SCRIPTS = yes                 Installation scripts was skipped
#
#NO_CHECKSUM =                    Do not check the MD5 sum for archive.
#
#NO_EXTRACT = yes                 Install ports without archive. 
#
#VERBOSE = yes                    Print extended infomatiion in execution 
#                                 time of install/deinstll scripts
#

.if !defined(_PREMKINCLUDED)
.include <bsd.port.pre.mk>
.endif

#-----------------------------------------------------------------------------------------
# Variables
#-----------------------------------------------------------------------------------------
OWN_SITE=http://www.swsoft.com

TOOLS_DIR=${LOCALBASE}/sbin
PKG_DEINSTALL?=${TOOLS_DIR}/pkg_deinstall
PORTUPGRADE?=${LOCALBASE}/sbin/portupgrade
PORTUPGRADE_PORT?=${PORTSDIR}/ports-mgmt/portupgrade
VALID_CATEGORIES+= swsoft
PACKAGE_INSTALLDIR?= ${LOCALBASE}
PKG_DB_DIR?= /var/db/pkg
LOG_FILE=/tmp/portupgrade-%s::%s.log
CHECKED_FILE=${WRKDIR}/.checked.${PORTNAME}
CONFLICTS_FILE=${WRKDIR}/.conflicts.${PORTNAME}
INSTALLED_FILE=${WRKDIR}/.installed.${PORTNAME}

.if !defined(FETCHDIR)
FETCHDIR= ${DISTDIR}
.endif

.if defined(VERBOSE) || defined(PLESK_INSTALLER_DEBUG)
VERBOSE_FLAG=1
PORTUPGRADE_FLAGS+= --verbose
.else
VERBOSE_FLAG=
.endif


SED_ENV+= \
	-e 's|%D|${PACKAGE_INSTALLDIR}|g' \
	-e 's|^\@exec \(.*\)|\"\1\"|g'

#-----------------------------------------------------------------------------------------
#Fetch
#-----------------------------------------------------------------------------------------
.if !defined(NO_CHECKSUM) && !defined(NO_EXTRACT)
pre-fetch: fetch-now
	@file=`${MD5} ${DISTDIR}/${DISTFILES} | ${AWK} -F '=' '{print $$2}'` && \
	sum=`${CAT} ${MD5_FILE} | ${GREP} ${DISTFILES} | ${AWK} -F '=' '{print $$2}'` && \
	if [ "X$$sum" != "X$$file" ]; then \
		${ECHO} "${DISTFILES} was to be refetch"; \
		${RM} -f ${DISTDIR}/${DISTFILES}; \
	fi
.else
pre-fetch: fetch-now
	@${MKDIR} ${.CURDIR}/work
.endif

.if !target(fetch-now)
fetch-now:
.   if defined(FETCH_SITES_LIST) && defined(FETCH_FILES_LIST) 
.      for _list in ${FETCH_SITES_LIST}
.        for _files in ${FETCH_FILES_LIST}
.	     if !exists(${FETCHDIR}/${_files})
		@cd ${FETCHDIR} && /usr/bin/fetch -FR ${_list}/${_files} || continue
.            endif
.        endfor
.      endfor
.   endif
.endif

#-----------------------------------------------------------------------------------------
#Extract
#-----------------------------------------------------------------------------------------
pre-extract: do-index pre-portupgrade do-portupgrade

#------------------------------------------------------------------------------------------
# Resolve conflicts 
#------------------------------------------------------------------------------------------
conflicts:
	@${MAKE} -DSINGLE_PORT all-conflicts

all-conflicts:
	@echo "==> Deinstall conflicts"
	@pkgdb -aFu
	@mkdir -p ${WRKDIR}
	@${MAKE} -V CONFLICTS > ${CONFLICTS_FILE}
.if !defined(SINGLE_PORT)
	@${MAKE} do-portupgrade -DCHECK_CONFLICTS
.endif
	@${PKG_DEINSTALL} -O -P -f `cat ${CONFLICTS_FILE}` >/dev/null 2>&1 && pkgdb -aFu || true

#------------------------------------------------------------------------------------------
# Resolve Depends
#------------------------------------------------------------------------------------------

#Check portupgrade
pre-portupgrade:
	@pkg_info 2>&1 | grep portupgrade >/dev/null 2>&1; \
	if [ $$? -ne 0 ]; then \
	   echo "==> Portupgrade not found. Installing..."; \
	   cd ${PORTUPGRADE_PORT} && make install clean; \
	fi

#Recursive requirements
#part 1
do-portupgrade:
	@mkdir -p ${WRKDIR}
	@rm -f ${INSTALLED_FILE} && touch ${INSTALLED_FILE}
	@rm -f ${CHECKED_FILE} && touch ${CHECKED_FILE}
	@pkg_info -o `find /var/db/pkg/ -type d -depth 1` > ${INSTALLED_FILE}
	@depends=`${MAKE} all-depends-list | xargs echo -n`; \
		${MAKE} DEPENDS_PSA="$$depends" COUNT=1 do-portupgrade1

#part 2
do-portupgrade1:
	@for i in ${DEPENDS_PSA}; do \
		cut_depend=`echo $$i | sed -e 's|${PORTSDIR}/||g`; \
		if [ "X${CHECK_CONFLICTS}" != "X" ]; then \
			cat ${CONFLICTS_FILE} | grep $$i /dev/null || \
			conflicts="`cd ${PORTSDIR}/$$cut_depend && ${MAKE} -V CONFLICTS`"; \
			echo "$$conflicts" >> ${CONFLICTS_FILE}; \
		fi; \
		installed="`cat ${INSTALLED_FILE} | grep $$cut_depend || true`"; \
		if [ "X$$installed" = "X" ]; then \
			depends="`cd ${PORTSDIR}/$$cut_depend && ${MAKE} all-depends-list | xargs echo -n`"; \
			count=`expr ${COUNT} + 1` && \
			${MAKE} DEPENDS_PSA="$$depends" COUNT=$$count do-portupgrade1 || exit 1; \
			if [ "X$$count" = "X15" ]; then \
				echo "Deep of recursion very big. Exit"; \
				exit 1; \
			fi; \
			if [ "X${CHECK_CONFLICTS}" = "X" ]; then \
				${PORTUPGRADE} -N ${PORTUPGRADE_FLAGS} -P -Ww -O -L ${LOG_FILE} $$cut_depend || \
				make do-error; \
				echo "$$cut_depend" >> ${INSTALLED_FILE}; \
			fi; \
		fi; \
	done;

.if !target(do-extract) && defined(NO_EXTRACT)
do-extract:
	@${MKDIR} ${WRKSRC}
.endif

#-----------------------------------------------------------------------------------------
#Configure 
#-----------------------------------------------------------------------------------------

.if defined(NO_CONFIGURE)
configure: extract
.endif

#-----------------------------------------------------------------------------------------
#Build targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_BUILD)

.if !target(build)
build: configure pre-build 
	@${TOUCH} ${TOUCH_FLAGS} ${BUILD_COOKIE}
.endif

.if !target(do-build)
do-build:
.endif

.endif #NO_BUILD

#-----------------------------------------------------------------------------------------
#Install targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_INSTALL)

pre-install:

.if !target(do-install)
do-install: do-install-pre do-install-now do-exec do-install-post
 
do-install-pre:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} PRE-INSTALL
. endif

.if !target(do-install-now)
do-install-now:
. if !defined(NO_EXTRACT) && !defined(NO_INSTALL)
	@echo -n "==> Copying files into installation directory... "
	@${CP} -RPf ${WRKSRC}/* ${PACKAGE_INSTALLDIR}/	
	@echo "done"
.endif
.endif

do-install-post:
. if !defined(NO_SCRIPTS)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL
. endif
.endif

.endif

reinstall: deinstall install

#-------------------------------------------------------------------------------------------
# Execute Command before and after main install/upgrade procedure
#-------------------------------------------------------------------------------------------
.if !target(product-pre-cmd)
product-pre-cmd:
	@pkgdb -aFu
	@dep_list=`pkg_info | awk '/^psa-/ {printf ("%s ",$$1);}'`; \
	if [ "X$$dep_list" = "X" ]; then \
		${PORTUPGRADE} -wPNa -L ${LOG_FILE}; \
	else \
		${PORTUPGRADE} -wPNa -L ${LOG_FILE} -x $$dep_list; \
	fi
.endif

.if !target(product_post-cmd)
product-post-cmd:
.endif

#-------------------------------------------------------------------------------------------
# Upgrade targets block
#-------------------------------------------------------------------------------------------
.if !target(upgrade)
upgrade: product-pre-upgrade do-upgrade post-upgrade

.if !target(pre-upgrade)
pre-upgrade:
.endif

.if !target(do-upgrade)
do-upgrade:
.endif

.if !target(post-upgrade)
post-upgrade:
.endif
.endif

#-------------------------------------------------------------------------------------------
# Set correct permissions 
#-------------------------------------------------------------------------------------------
EXEC_LIST!= cat ${.CURDIR}/pkg-plist | grep '@exec ' | sed ${SED_ENV}

.if !target(do-exec)
do-exec:
	@for CMD in ${EXEC_LIST}; do \
		${SH} -c "$$CMD"; \
	done
.endif

#-------------------------------------------------------------------------------------------
# Error processing
#-------------------------------------------------------------------------------------------
do-error:
		@echo "Unable to install some components"
		@exit 1

#-------------------------------------------------------------------------------------------
# End
#-------------------------------------------------------------------------------------------

pre-index: 
	@${CP} -f ${INDEXDIR}/${INDEXFILE} ${INDEXDIR}/${INDEXFILE}.bkp 2>/dev/null || true
	
do-index:
	@describe="`${MAKE} describe`"; \
	if [ "X$$describe" != "X" ]; then \
		origin="`echo $$describe | awk -F '|' '{print $$2}'| sed -e 's|^${PORTSDIR}/\(.*\)|\1|g'`"; \
		portname="`echo $$describe | awk -F '|' '{print $$1}'| sed -e 's|\(.*\)\-[[:digit:]]*.*|\1|g'`"; \
		if ! ${GREP} -q "^$$portname-[[:digit:]]" ${INDEXDIR}/${INDEXFILE} > /dev/null; then \
			echo $$describe >> ${INDEXDIR}/${INDEXFILE}; \
		else \
			sed -i "" -e "s#^$$portname-[[:digit:]]\(.*\)|${PORTSDIR}/$$origin\|\(.*\)#$$describe#" ${INDEXDIR}/${INDEXFILE}; \
		fi; \
	else \
.               error "Inconsistent port"; \
	fi

index: do-index

.include <bsd.port.post.mk>

.if defined(USE_PHP)
.include "${PORTSDIR}/Mk/bsd.php.mk"
.endif

